<!DOCTYPE html>
<html>
    <head>
        <meta name = "viewport" content = "width=device-width">
        <title>Rectangle</title>
        <style>
            * {
                box-sizing: border-box;
                margin: 0;
                padding: 0;
            }
            html, body {
                height: 100%;
                width: 100%;
            }
            body {
                background-color: #30494a;
                color: white;
            }
        </style>
    </head>
    <body>
        <h1>Rectangle controller</h1>
        <canvas></canvas>
        <p>Use the keyboard to move the red square</p>
        <!-- <script src="control.js" type="text/javascript"></script> -->
    </body>

    <script>
    document.addEventListener('DOMContentLoaded', ()=>{
        console.log("document is ready");
        
        // MAIN CODE
        const context = document.querySelector("canvas").getContext("2d");
        const canvasHeight = 360;
        const canvasWidth = 640;
        context.canvas.height = canvasHeight;
        context.canvas.width = canvasWidth;

        // CONTROLLERS
        let menuController = {};
        let stageController = {
            left: false,
            right: false,
            up: false,
            keyListener: function (event) {
                let key_state = (event.type == "keydown") ? true : false;

                switch (event.keyCode) {
                    case 37 || 113 :
                        stageController.left = key_state;
                    break;
                    case 38 || 111 :
                        stageController.up = key_state;
                    break;
                    case 39 || 114 :
                        stageController.right = key_state;
                    break;
                }
            }
        };

        // MODELS
        let menuModel;
        let stageModel;
        let platformModel;
        // TODO stageModel.platforms
        /*
        // TODO check if rectangle's x value gets in platforms x fange, and if so, check it's y value
        TODO rectangle.onPlatform, if true, do not check other platforms
        TODO DO IT ON UNITY
        TODO do object and component architecture
        TODO hitbox object and check if some other hitbox interfere with the hitbox of one component
        IDEA for the future : targetting one oponent to fire with a fire weapon (or a magical attack), or jump to the target on hand-to-hand (short-range) combat
         -> targetting an oponent allow to dodge attacks of that oponent, but not the others; user must press arrows and doge key; slow the character's moving speed.
        */
        let recModel;
        let platforms = [];

        // REQUEST FUNC
        const doRequest = (method, url, callback) => {
            const http = new XMLHttpRequest();
            http.onreadystatechange = ()=>{
                
                if (http.readyState == 4 && http.status == 200) {
                    callback(JSON.parse(http.response));
                }
            }
            http.open(method, url, false);
            http.send();
        };

        // GETTING ALL MODELS
        doRequest('GET', 'http://localhost:8010/platforms', (plts)=>{
            platforms = plts;
        });
        doRequest('GET', 'http://localhost:8010/rectangle', (rectangle)=>{
            recModel = rectangle;
        });

        // LOOP FUNC
        this.loop = function(){
            // RECTANGLE's control
            if (stageController.up && recModel.jumping == false) {
                recModel.y_velocity -= 25
                recModel.jumping = true;
            }
            if (stageController.left) {
                recModel.x_velocity -= 0.5;
            }
            if (stageController.right) {
                recModel.x_velocity += 0.5;
            }

            recModel.y_velocity += 1.5; //gravity
            recModel.x += recModel.x_velocity;
            recModel.y += recModel.y_velocity;
            recModel.x_velocity *= 0.9; //friction
            // recModel.y_velocity *= 0.9; //friction

            // if rectangle is falling below floor line
            if (recModel.y > canvasHeight - 16 - 32) {
                recModel.jumping = false;
                recModel.y = canvasHeight - 16 - 32;
                recModel.y_velocity = 0;
            }

            // if rectangle is going off the left of the screen
            if (recModel.x < -32) {
                recModel.x = canvasWidth;
            } else if (recModel.x > canvasWidth) { // if rectangle goes past right
                recModel.x = -32;
            }


            // DRAWING ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~
            // BACKGROUND
            context.fillStyle = "#202020";
            context.fillRect(0, 0, canvasWidth, canvasHeight); // x, y, width, height

            // DRAWING THE RECTANGLE
            context.fillStyle = recModel.color;
            context.beginPath();
            context.rect(recModel.x, recModel.y, recModel.width, recModel.height);
            context.fill();
            
            // PLATFORMS
            platforms.map((plt)=>{
                context.fillStyle = plt.color;
                context.fillRect(plt.x, plt.y, plt.width, plt.height);
            });

            window.requestAnimationFrame(loop);
        };

        window.addEventListener("keydown", stageController.keyListener);
        window.addEventListener("keyup", stageController.keyListener);
        window.requestAnimationFrame(loop);
    });
    </script>
</html>